using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections.Specialized;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Drawing;
using Syncfusion.Styles;
using Syncfusion.Windows.Forms;


namespace GGC_Sample2005
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    # region * DataSource *

    private DataTable GetTable()
    {
      DataTable dt = new DataTable();

      int nCols = 5;
      int nRows = 10;
      Random r = new Random();

      for (int i = 0; i < nCols; i++)
      {
        if (i == 3)
          dt.Columns.Add(new DataColumn("Number", typeof(int)));
        else
          dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));
      }

      for (int i = 0; i < nRows; ++i)
      {
        DataRow dr = dt.NewRow();
        for (int j = 0; j < nCols; j++)
        {
          if (j == 3)
            dr[j] = r.Next(10);
          else
            dr[j] = string.Format("row{0} col{1}", i, j);
        }
        dt.Rows.Add(dr);
      }
      return dt;
    }

    # endregion

    private void Form1_Load(object sender, EventArgs e)
    {
        DataTable dt = GetTable();
        this.gridGroupingControl1.DataSource = dt;
        this.gridGroupingControl1.TableControlCurrentCellValidating += new GridTableControlCancelEventHandler(gridGroupingControl1_TableControlCurrentCellValidating);
    }

    void gridGroupingControl1_TableControlCurrentCellValidating(object sender, GridTableControlCancelEventArgs e)
    {
      GridCurrentCell cc = e.TableControl.CurrentCell;

      string newValue = cc.Renderer.ControlText;
      string oldValue = e.TableControl.Model[cc.RowIndex, cc.ColIndex].Text;

      if (cc.Renderer.StyleInfo.CellValueType == typeof(int))
      {
        double d;
        try
        {
            d = double.Parse(newValue);
        }
        catch
        {
          e.Inner.Cancel = true;
          cc.ErrorMessage = "Invalid entry. Only Numbers allowed";
          cc.Renderer.ControlText = oldValue;          
        }
      }
    }
   
  }

}